/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta2

import (
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// AWSClusterLister helps list AWSClusters.
// All objects returned here must be treated as read-only.
type AWSClusterLister interface {
	// List lists all AWSClusters in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSCluster, err error)
	// AWSClusters returns an object that can list and get AWSClusters.
	AWSClusters(namespace string) AWSClusterNamespaceLister
	AWSClusterListerExpansion
}

// aWSClusterLister implements the AWSClusterLister interface.
type aWSClusterLister struct {
	indexer cache.Indexer
}

// NewAWSClusterLister returns a new AWSClusterLister.
func NewAWSClusterLister(indexer cache.Indexer) AWSClusterLister {
	return &aWSClusterLister{indexer: indexer}
}

// List lists all AWSClusters in the indexer.
func (s *aWSClusterLister) List(selector labels.Selector) (ret []*v1beta2.AWSCluster, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSCluster))
	})
	return ret, err
}

// AWSClusters returns an object that can list and get AWSClusters.
func (s *aWSClusterLister) AWSClusters(namespace string) AWSClusterNamespaceLister {
	return aWSClusterNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// AWSClusterNamespaceLister helps list and get AWSClusters.
// All objects returned here must be treated as read-only.
type AWSClusterNamespaceLister interface {
	// List lists all AWSClusters in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta2.AWSCluster, err error)
	// Get retrieves the AWSCluster from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta2.AWSCluster, error)
	AWSClusterNamespaceListerExpansion
}

// aWSClusterNamespaceLister implements the AWSClusterNamespaceLister
// interface.
type aWSClusterNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all AWSClusters in the indexer for a given namespace.
func (s aWSClusterNamespaceLister) List(selector labels.Selector) (ret []*v1beta2.AWSCluster, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta2.AWSCluster))
	})
	return ret, err
}

// Get retrieves the AWSCluster from the indexer for a given namespace and name.
func (s aWSClusterNamespaceLister) Get(name string) (*v1beta2.AWSCluster, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta2.Resource("awscluster"), name)
	}
	return obj.(*v1beta2.AWSCluster), nil
}
